<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Accumulation counter -- entry </title>
    <link rel="stylesheet" href="MFDcount.css">
</head>

<body onload=onload_entry_counter()>
<div class=top>

<label for="ta_input">Target accumulation:</label>
<input type="text" id="ta_input" name="ta_input" size=4> 
<button class="startstop" id="button_startstop" type="button" onclick="startStop()">Start</button>
<br>
<br>
Experiment number: <span id="exp_number">---</span>
<div class="running">Experiment is <span id="running">stopped</span>.</div>
<br>
<br>
<label for="exp_name_input">Exp. name:</label>
<input type="text" id="exp_name_input" name="exp_name_input" size=18>
<div class="running">Time: <span id="time">--:--</span></div>
</div>

<div class="bottom">
<span class="accumulation" id="cum_in">-</span>
<p>
  <button class="count-button-entry" id="button_entry" type="button" onclick="add(1,'entry')">
    <img src="fig/entry.svg" width=100% height=100%>
    <br><span class="gowait" id="gowait"> </span>
  </button>
</p>
<span class="accumulation" id="accumulation">-</span><br>
<p>
  <button class="correction-button" id="correction_entry" type="button" onclick="add(-1,'entry_correction')">Correction (-1)</button>
</p>
</div>

<script>

function onload_entry_counter() {
  // If the entry counter page is (re)loaded during the experiment is running then get all data from the server and put them in the 
  // webpage elements. 
  // If the entry counter page is (re)loaded and the experiment is not running, then
  //  - set the experiment counter to +1 of what is on the server (that was the previous run)
  //  - set a new name for the experiment (date-time)
  //  - reset the accumulation to 0 in the server file and this webpage.
  //  - empty the target accumulation text in the server file and this webpage.
  //  - reset the cumulative in- and outflows to 0 in the server files and this webpage.
  //  - set the text of the start/stop button to "start" and the text of the experiment status to "stopped".
  const xhttp = new XMLHttpRequest();
  xhttp.onload = function() {
    if (xhttp.status === 200) {
      // Parse the JSON response
      var response = JSON.parse(xhttp.responseText);

      // window.alert(xhttp.responseText);
      // window.alert(response.running);
      // Handle the JSON response
      document.getElementById("accumulation").innerHTML = "Accumulation: ".concat(response.accumulation,"/",response.ta);
      document.getElementById("ta_input").value = response.ta;
      document.getElementById("cum_in").innerHTML = "Cumulative inflow: ".concat(response.cum_in);
      document.getElementById("exp_number").innerHTML = response.no;
      document.getElementById("exp_name_input").value = response.name;
      document.getElementById("button_startstop").innerText = response.ss_button;
      document.getElementById("running").innerHTML = response.running;

      if (response.running == "running"){ 
        // document.getElementById("ta_input").setAttribute('readonly',"true");
        // document.getElementById("ta_input").style.backgroundColor = "lightgray";
        // document.getElementById("button_entry").disabled = false;
        // document.getElementById("button_entry").style.backgroundColor = 'lightgreen';
        // document.getElementById("gowait").innerHTML = "Go!";
        // document.getElementById("correction_entry").disabled = false;
      } else {
        //document.getElementById("ta_input").setAttribute('readonly',"false");
        document.getElementById("ta_input").removeAttribute('readonly');
        document.getElementById("ta_input").style.backgroundColor = "";
        // document.getElementById("button_entry").disabled = true;
        document.getElementById("button_entry").style.backgroundColor = '';
        document.getElementById("gowait").innerHTML = " ";
        // document.getElementById("correction_entry").disabled = true;

      //document.getElementById("ta_input").setAttribute('readonly',"true");
      //document.getElementById("button_startstop").innerText = "Stop";
    }
   } else {
        console.error('Error fetching data');
    }

    //document.getElementById("accumulation").innerHTML =
    //this.responseText;
  }
  xhttp.open("POST", "onload_entry_counter.php", true);
  xhttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
  xhttp.send();  
}

function startStop() {
  // start or stop the experiment (see below)
  const xhttp = new XMLHttpRequest();
  xhttp.onload = function() {
    if (xhttp.status === 200) {
      // Parse the JSON response
      // window.alert(xhttp.responseText)
      var response = JSON.parse(xhttp.responseText);

      // Handle the JSON response
      document.getElementById("accumulation").innerHTML = response.accumulation;
      
      document.getElementById("button_startstop").innerText = response.ss_button;
      document.getElementById("running").innerHTML = response.running;
      if (response.running == "running"){ 
        // document.getElementById("ta_input").setAttribute('readonly',"true");
        document.getElementById("ta_input").style.backgroundColor = "lightgray";
        // document.getElementById("button_entry").disabled = false;
        document.getElementById("button_entry").style.backgroundColor = 'lightgreen';
        document.getElementById("gowait").innerHTML = "Go!";
        // document.getElementById("correction_entry").disabled = false;
      } else {
        // window.alert(response.running)
        // document.getElementById("ta_input").removeAttribute('readonly');
        document.getElementById("ta_input").style.backgroundColor = "";
        // document.getElementById("button_entry").disabled = true;
        //document.getElementById("button_entry").style.backgroundColor = '#EF5050';
        //document.getElementById("gowait").innerHTML = " ";
        // document.getElementById("correction_entry").disabled = true;
        document.getElementById("exp_number").innerHTML = response.no;
        document.getElementById("exp_name_input").value = response.name;
      }

    } else {
        console.error('Error fetching data');
    }
  }
  // Start
  // - read target accumulation, experiment number and name from webpage and store all on server
  // - open new log file on server

  // Stop
  // - determine new exp number and name (date)
  // - empty ta field
  // rename record file to experiment number +name.
  // 
  const ss = document.getElementById("button_startstop").innerText;

  if(ss == "Start") { // Start was pushed.
  const exp_number =  document.getElementById('exp_number').innerHTML;
  const exp_name =  document.getElementById('exp_name_input').value;
  // Get target accumulation value
  const ta = document.getElementById('ta_input').value;
  // Check if the value is an integer
  const isInteger = Number.isInteger(Number(ta)); 
  // empty string converts to int 0, so testing for empty string is necessary.

  // Set background color accordingly
  if (isInteger && ta !== "") { 
    document.getElementById("ta_input").style.backgroundColor = ''; // default color
  } else {
    document.getElementById("ta_input").style.backgroundColor = '#FFC0CB'; // red
  }
  if (isInteger && ta !== "") { // and some other conditions?
    xhttp.open("POST", "startstop.php", true);
    xhttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
    xhttp.send("ta=".concat(String(ta),"&act=start&no=",String(exp_number),"&name=",String(exp_name)));  
  }

  } else { // Stop was pushed
    // window.alert("Stop was pushed")
    xhttp.open("POST", "startstop.php", true);
    xhttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
    xhttp.send("act=stop");  
    //xhttp.send("ta=".concat(String(ta),"&act=start&no=",String(exp_number),"&name=",String(exp_name)));  
  }
  
}

function getStatus() {
  const xhttp = new XMLHttpRequest();
  xhttp.onload = function() {
    if (xhttp.status === 200) {
      // Parse the JSON response
      var response = JSON.parse(xhttp.responseText);

      // Handle the JSON response
      document.getElementById("accumulation").innerHTML = "Accumulation: ".concat(response.accumulation,"/",response.ta);
      document.getElementById("cum_in").innerHTML = "Cumulative inflow: ".concat(response.cum_in);
      // window.alert(response.goorwait);
      if (response.running == "running") {
        if (response.goorwait === "Go!") {
          document.getElementById("gowait").innerHTML = "Go!";
          document.getElementById("button_entry").style.backgroundColor = 'lightgreen';
        } 
        else if (response.goorwait === "Wait!") {
          document.getElementById("gowait").innerHTML = "Wait!";
          document.getElementById("button_entry").style.backgroundColor = '#EF5050';
        }
        
      } else {
        document.getElementById("gowait").innerHTML = " ";
        document.getElementById("button_entry").style.backgroundColor = "lightgray";
        //document.getElementById("time").innerHTML = "--:--";
      }
      document.getElementById("time").innerHTML = response.runtime;

    } else {
        console.error('Error fetching data');
    }

    //document.getElementById("accumulation").innerHTML =
    //this.responseText;
  }
  //xhttp.open("GET", "get_count.php");
  //xhttp.send();
  xhttp.open("POST", "get_status.php", true);
  xhttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
  xhttp.send();
}

function add(n,reason) {
  const xhttp = new XMLHttpRequest();
  xhttp.onload = function() {
    getStatus()
  }
  xhttp.open("POST", "add.php", true);
  xhttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
  xhttp.send("n=".concat(String(n),"&reason=",reason));
}

// Poll state every 100 ms
var statusWatcher = setInterval("getStatus()",100);    
// clearInterval(statusWatcher); // abort status watching

</script>

</body>
</html>
